/*
  d. bodnar  revised 6-16-2016 with Rotary Encoder
  modified msport 13-03-2020 for 1.44" 128x128 SPI TFT display or 1.8" 128x160
  modified msport for 4x4 keyboard to command points and accessories
  library ADAFRUIT
  Version  ST7735 from graphictest example
  encoder library with reset
  02-01-2021 (C) Locoduino licence Open Software
*/
#include <Adafruit_GFX.h>    // Core graphics library
#include <Adafruit_ST7735.h> // Hardware-specific library
#include <SPI.h>
#include<EEPROM.h>

// Color definitions
#define BLACK   0x0000
#define BLUE    0x001F
#define RED     0xF800
#define GREEN   0x07E0
#define CYAN    0x07FF
#define MAGENTA 0xF81F
#define YELLOW  0xFFE0  
#define WHITE   0xFFFF

#define TFT_CS     10  // 10
#define TFT_RST    -1  // 9 you can also connect this to the Arduino reset
                       // in which case, set this #define pin to -1!
#define TFT_DC     9  // 8
Adafruit_ST7735 tft = Adafruit_ST7735(TFT_CS,  TFT_DC, TFT_RST);

#include "Arduino.h"
#include "EncoderStepCounter.h"
#define ENCODER_PIN1 2
#define ENCODER_INT2 digitalPinToInterrupt(ENCODER_PIN1)
#define ENCODER_PIN2 3
#define ENCODER_INT1 digitalPinToInterrupt(ENCODER_PIN2)
// Create instance for one full step encoder
EncoderStepCounter encoder(ENCODER_PIN1, ENCODER_PIN2);

const int ledPin =  12;      // the number of the LED pin
const int batPin =  21;      // battery A7
int buttonPin = 4; // button on rotary
int positionSpeed; // keep encoder position for speed
int positionPoint; // keep encoder position for Point numberTurntable
int positionTurntable; // keep encoder position for Turntable
int positionAccessory; // keep encoder position for Accessory number
int dir = 0; // direction
int buttonState = 0;
int encoderChange = 0; // flag to show encoder changed

byte Key;
char key ;
// int LED = 11; // LED to blink when DCC packets are sent in loop : not used
byte Fx = 0;
// Array set for 4 Loco2 - change the 7 numbers in the next 7 declarations
int maxLocos = 4; // number of loco addresses
int LocoAddress[4] = {3, 36, 35, 12};
int LocoDirection[4] = {1, 1, 1, 1};
int LocoSpeed[4] = {0, 0, 0, 0};
byte LocoFN[4][4]= {{0, 0, 0, 0},{0, 0, 0, 0},{0, 0, 0, 0},{0, 0, 0, 0}} ; // [LIGNES][COLONNES] for 13-20 and 21-28 2&3 groups / loco addresses
byte LocoFN0to4[4]= {0, 0, 0, 0}; // 0 group
byte LocoFN5to8[4]= {0, 0, 0, 0}; // 0 group
byte LocoFN9to12[4]= {0, 0, 0, 0}; // 1 group
byte LocoFN13to20[4]= {0, 0, 0, 0}; // 2 group
byte LocoFN21to28[4]= {0, 0, 0, 0}; // 3 group
byte group[4]= {0, 0, 0, 0}; // 9-24 in progress
int delta[4] = {0,4,12,20};

boolean AccessoryDone = false;
int PointAddressDble = 2;
int AccessoryAddressDble = 2;
int TurntableAddressDble = 2;
int xxxxx = 0;
int pot1Pin = A3;
int potValue = 0;
int NewPotValue = 0;
int potValueOld = 0;
int counter = 0;

float vBat = 3.7;
int ZeroSpeedFlag = 0;
int ActiveAddress = 0; // make address1 active

int z = 0;
int powerTemp = 0;
int i = 0;
#include <Keypad.h>
const byte ROWS = 4; //four rows
const byte COLS = 4; //four columns
char keys[ROWS][COLS] = {
  {'1', '2', '3', 'A'},
  {'4', '5', '6', 'B'},
  {'7', '8', '9', 'C'},
  {'*', '0', '#', 'D'}
};
byte rowPins[ROWS] = {A0, A1, A2, A3}; //{A3, A2, A1, A0}; // {8, 7, 6, 5}// ; // //connect to the row pinouts of the keypad
byte colPins[COLS] = {5,6,7,8};// {A3, A2, A1, A0}; // //connect to the column pinouts of the keypad
Keypad keypad = Keypad( makeKeymap(keys), rowPins, colPins, ROWS, COLS );
boolean blink = false;
boolean ledPin_state;
unsigned long DCCMillis = 0;        // will store time when command is triggered
unsigned long previousMillis = 0;        // will store last time LED was updated
unsigned long currentMillis = millis();
const long interval = 300;

int debug = 0; // set to 1 to show debug info on serial port - may cause issues with DCC++ depending on what is sent

// Call tick on every change interrupt
void interrupt() {
  encoder.tick();
}

//------------------------------------------------------------------------------
void setup() {
  Serial.begin(115200);
  delay(200);
  tft.initR(INITR_144GREENTAB);   // initialize a ST7735S chip, black tab
//  tft.initR(INITR_BLACKTAB);   // initialize a ST7735S chip, black tab 1.8" TFT
  delay(200);
  encoder.begin();  // Initialize encoder
  // Initialize interrupts
  attachInterrupt(ENCODER_INT1, interrupt, CHANGE);
  attachInterrupt(ENCODER_INT2, interrupt, CHANGE);

//  pinMode(LED, OUTPUT);

  tft.setRotation ( 1 );
  tft.setTextWrap(false);
  tft.fillScreen(BLACK);
  tft.setCursor(0, 0);  // col, ligne 0, 30
  tft.setTextColor(WHITE, BLACK);
  tft.setTextSize(2);  // 6 lines 10 char size 2 portrait
  getAddresses();  // read eeprom
  tft.println(F("Appuyer:"));
  tft.println(F("changer "));
  tft.println(F("Nb locos")); 
  tft.setTextColor(YELLOW);
  tft.println(maxLocos);
  pinMode(batPin, INPUT);              // to get battery voltage on A7
  vBat = analogRead(batPin);
  vBat = vBat / 205 ;
  tft.setTextColor(CYAN, BLACK);
  tft.println(F("Batterie :")); 
  tft.print(vBat, 1); 
  tft.println(F(" V")); 
  delay(2000);
  buttonState = digitalRead(buttonPin);
  // Serial.println(buttonState);
  if (buttonState == LOW) {
    getNumberOfLocos();
  }
  tft.setCursor(0, 0);  // col, ligne 0, 0
  tft.fillScreen(BLACK);
  tft.setTextColor(YELLOW);
  tft.println(F("DCC++"));
  tft.println(F("Throttle"));
  tft.println(F("Ver PAD_T+"));  
  tft.println(F("02-01-2021")); 
  tft.setTextColor(WHITE, BLACK);
  if (debug == 1) Serial.println("");
  Serial.print(F("<1>"));  // power ON to DCC++ unit
  delay(1500);
  pinMode(ledPin, OUTPUT);              // Sets the digital pin as output.
  digitalWrite(ledPin, HIGH);           // Turn the LED on.
  ledPin_state = digitalRead(ledPin);   // Store initial LED state. HIGH when LED is on.
  tft.fillScreen(BLACK);
  doMainLCD(); //
}  // END SETUP

void getNumberOfLocos() {  // initial choice of loco number to cycle in
  //maxLocos = 4;// number of loco addresses
  tft.fillScreen(BLACK);  // clears the screen and buffer 
  tft.setCursor(0, 0);
  tft.setTextColor(WHITE);
  tft.println(F("Nb locos")); tft.print(F("  = ")); 
  tft.setTextColor(CYAN); tft.print(maxLocos);
  tft.println("");
  tft.setTextColor(WHITE);
  tft.println(F("Nouveau :")); 
  tft.print(F(" 1-4 : "));  
  tft.setTextColor(CYAN);
  do {
    key = keypad.getKey();
    if (debug == 1) Serial.print("key = ");
    if (debug == 1) Serial.println(key);
    key = key - 48 - 1; // convert from ascii value
    //Serial.println(key);
    if (key == 1 || key == 2 || key == 3 || key == 4) { // 1-4
      maxLocos = key + 1;
      if (debug == 1)    Serial.print(F("new maxLocos = "));
      if (debug == 1)  Serial.println(maxLocos);
      tft.print(maxLocos);
      delay(1400);
      saveAddresses();
      break;
    }
  } while (key != 1 || key != 2 || key != 3 || key != 4);
}

void loop() {

  key = keypad.getKey();
  if (key == 42) { // *
    all2ZeroSpeeed();
    getLocoAddress();
    key = 0;
  }
  // ROUTINE USING ROTARY ENCODER FOR SPEED AND BUTTON ON IT FOR DIRECTION
  signed char pos = encoder.getPosition();
  if (pos != 0) {
    positionSpeed += pos;
    if (positionSpeed < 0) {positionSpeed = 0;}
    if (positionSpeed > 126) {positionSpeed = 126;}
    LocoSpeed[ActiveAddress] = positionSpeed ; // 4 ; // 
    encoder.reset();
    // Serial.println(positionSpeed);
    doDCC();
    doMainLCD();    
  }
  buttonState = digitalRead(buttonPin);
  // Serial.println(buttonState);
  if (buttonState == LOW) {
    delay(50);
    buttonState = digitalRead(buttonPin); // check a 2nd time to be sure
    if (buttonState == LOW) {// check a 2nd time to be sure
      LocoDirection[ActiveAddress] = !LocoDirection[ActiveAddress];
      if (LocoDirection[ActiveAddress] == 0) {
        digitalWrite(ledPin, LOW);
      }
      else digitalWrite(ledPin, HIGH);
      doDCC();
      doMainLCD();
      do {  // routine to stay here till button released & not toggle direction
        buttonState = digitalRead(buttonPin);
      }      while (buttonState == LOW);
    }
  }
  if (key == 35) { // #
    ActiveAddress++;
    if (ActiveAddress >= maxLocos) ActiveAddress = 0;
    tft.setCursor (60, 40);       // col, line
    tft.print("     ");    
    doMainLCD();
    delay(200);
    key = 0;
    positionSpeed = LocoSpeed[ActiveAddress];
    doDCC();
  }
  if (key != 42 && key != 35 && key >= 40 && key <= 57) { // figure or letter, not #, not * 
    doFunction();
  }
  if (key == 65) doPoint();                  // letter A only
//  if (key == 66)  Serial.print ("<a 17 1 1>") ;   // letter B only, TurntableReverseDirection
  if (key == 66) doTurntable();               // letter B only
  if (key == 67) doAccessory();              // letter C only
  if (key == 68) doChangeGroupFunction() ;   // letter D only

}  //END LOOP

//START DO FUNCTION BUTTONS
int doFunction() {
  key = key - 48 - 1; // convert from ascii value, 48 = zero, press 1 gives F0
  tft.setCursor (84, 60);       // go to 6th line, 12 per space ex 84, one space before F
  tft.print("F");
  tft.setTextColor(YELLOW, BLACK);  
  tft.print(key + (delta[group[ActiveAddress]]) , DEC ); // display Function #
  tft.setTextColor(WHITE, BLACK);
  tft.print("  ");
  if (debug == 1) Serial.print("got a keypad button ");
  if (debug == 1) Serial.println(key + (8 * group[ActiveAddress]), DEC);
    
switch (group[ActiveAddress]) {
  case 0:
  if (key <= 4) {
    if (bitRead(LocoFN0to4[ActiveAddress], key) == 0 ) {
      bitWrite(LocoFN0to4[ActiveAddress], key, 1);
    }
    else {
      if (bitRead(LocoFN0to4[ActiveAddress], key) == 1 ) {
        bitWrite(LocoFN0to4[ActiveAddress], key, 0);
      }
    }
    doDCCfunction04();
    if (debug == 1) Serial.print(LocoFN0to4[ActiveAddress], BIN);
    if (debug == 1) Serial.println(" LocoFN0to4[ActiveAddress] d ");
    if (debug == 1) Serial.print(LocoFN0to4[ActiveAddress], DEC);
    if (debug == 1) Serial.println(" LocoFN0to4[ActiveAddress]");
  }
  
  if (key >= 5 && key <= 8) {
    key = key - 5;
    if (bitRead(LocoFN5to8[ActiveAddress], key) == 0 ) {
      bitWrite(LocoFN5to8[ActiveAddress], key, 1);
    }
    else {
      if (bitRead(LocoFN5to8[ActiveAddress], key) == 1 ) {
        bitWrite(LocoFN5to8[ActiveAddress], key, 0);
      }
    }
    doDCCfunction58();
    if (debug == 1) Serial.print(LocoFN5to8[ActiveAddress], BIN);
    if (debug == 1) Serial.println(" LocoFN5to8[ActiveAddress] d ");
    if (debug == 1) Serial.print(LocoFN5to8[ActiveAddress], DEC);
    if (debug == 1) Serial.println("LocoFN5to8[ActiveAddress]");
  }
  break;
  case 1: // 9-12
  if (key >= 5 && key <= 8) {
    key = key - 5;
    if (bitRead(LocoFN9to12[ActiveAddress], key) == 0 ) {
      bitWrite(LocoFN9to12[ActiveAddress], key, 1);
    }
    else {
      if (bitRead(LocoFN9to12[ActiveAddress], key) == 1 ) {
        bitWrite(LocoFN9to12[ActiveAddress], key, 0);
      }
    }
    doDCCfunction912();
  }
  break;
  case 2: // 13-20
  if (key >= 0 && key <= 8)  {
    key = key - 1;
    if (bitRead(LocoFN13to20[ActiveAddress], key) == 0 ) {
      bitWrite(LocoFN13to20[ActiveAddress], key, 1);
    }
    else {
      if (bitRead(LocoFN13to20[ActiveAddress], key) == 1 ) {
        bitWrite(LocoFN13to20[ActiveAddress], key, 0);
      }
    }
    doDCCfunction1320();
  }
  break;
  case 3: // 21-28
  if (key >= 0 && key <= 8) {
    key = key - 1;
    if (bitRead(LocoFN21to28[ActiveAddress], key) == 0 ) {
      bitWrite(LocoFN21to28[ActiveAddress], key, 1);
    }
    else {
      if (bitRead(LocoFN21to28[ActiveAddress], key) == 1 ) {
        bitWrite(LocoFN21to28[ActiveAddress], key, 0);
      }
    }
    doDCCfunction2128();
  }
  break;
  default:
    // statements
  break;
  }
   
  if (key == -1)
  {
  tft.setCursor (84,60);       // go to end of 6th line, 6 char ex 84,2
    tft.print("  F ");
    // key = 0;
    tft.print(key, DEC); // modif inversion des deux lignes,  = 0 comment
    LocoFN0to4[ActiveAddress] = B00000000; //clear variables for which functions are set
    LocoFN5to8[ActiveAddress] = B00000000;
    if ( group[ActiveAddress] == 0) {
      doDCCfunction04();
      doDCCfunction58();
    }
    if ( group[ActiveAddress] == 1) {  LocoFN9to12[ActiveAddress] = B00000000;  doDCCfunction912();}
    if ( group[ActiveAddress] == 2) {  LocoFN13to20[ActiveAddress] = B00000000;  doDCCfunction1320();}
    if ( group[ActiveAddress] == 3) {  LocoFN21to28[ActiveAddress] = B00000000;  doDCCfunction2128();}
    delay(500);
    key = 0;
  }
  key = 0;
  // delay(500);
  doMainLCD();
}//END DO FUNCTION BUTTONS


int doPoint() { // START DO POINT - SWITCH
 while ((key == 65 || (key == 0)) ) {  // A 65 || (key == 0)  
  key = keypad.getKey();
  doPointLCD();        
  // ROUTINE USING ROTARY ENCODER FOR POINTS AND BUTTON ON IT TO TRIGGER COMMAND
  signed char pos = encoder.getPosition();
  if (pos != 0) {
    positionPoint += pos;
    if (positionPoint < 2) {positionPoint = 2;}
    if (positionPoint > 126) {positionPoint = 126;}
    PointAddressDble = positionPoint ; // + 2 ; // 
    encoder.reset();
    doPointLCD();   
  }
  buttonState = digitalRead(buttonPin);
  if (buttonState == LOW) {
    delay(50);
    buttonState = digitalRead(buttonPin); // check a 2nd time to be sure
    if (buttonState == LOW) {// check a 2nd time to be sure
      doDCCpoint();  
      do {  // routine to stay here till button released & not triggering accessory
        buttonState = digitalRead(buttonPin); 
        tft.setCursor(0, 100); // start of 4th line
        tft.setTextColor(RED, BLACK);
        tft.print("COMMANDE   ");         
        tft.setTextColor(WHITE, BLACK);
        tft.print(PointAddressDble / 2 , DEC);          
      }      while (buttonState == LOW);
    }
  }
 }  // end while
  if ((key != 65 && (key != 0)) ) {
    doMainLCD();
    delay(200);
    key = 0;
    doDCC(); // driving loco
    group[ActiveAddress]--; // in order to erase message
    doChangeGroupFunction();
  }
}  //  END DO POINT 

int doAccessory() { //START DO ACCESSORY
 while ((key == 67 || (key == 0)) ) {  // C 67 || (key == 0)
  key = keypad.getKey();
  doAccessoryLCD();
    // ROUTINE USING ROTARY ENCODER FOR ACCESSORIES AND BUTTON ON IT TO TRIGGER COMMAND
  signed char pos = encoder.getPosition();
  if (pos != 0) {
    positionAccessory += pos;
    if (positionAccessory < 2) {positionAccessory = 2;}
    if (positionAccessory > 126) {positionAccessory = 126;}
    AccessoryAddressDble = positionAccessory ; // + 2 ; // 
    encoder.reset();
    doAccessoryLCD();   
  }
  buttonState = digitalRead(buttonPin);
  if (buttonState == LOW) {
    delay(50);
    buttonState = digitalRead(buttonPin); // check a 2nd time to be sure
    if (buttonState == LOW) {// check a 2nd time to be sure
      doDCCaccessory();  
      do {  // routine to stay here till button released & not triggering accessory
        buttonState = digitalRead(buttonPin); 
        tft.setCursor(0, 100); // start of 5th line
        tft.setTextColor(RED, BLACK);
        tft.print("COMMANDE   ");         
        tft.setTextColor(WHITE, BLACK);
        tft.print(AccessoryAddressDble , DEC);          
      }      while (buttonState == LOW);
    }
  }
 }  // end while
  if ((key != 67 && (key != 0)) ) {
    doMainLCD();
    delay(200);
    key = 0;
    doDCC(); // driving loco
    group[ActiveAddress]--; // in order to erase message
    doChangeGroupFunction();
  }
} // END DO ACCESSSORY


int doTurntable() { //START DO TURNTABLE
 while ((key == 66 || (key == 0)) ) {  // B 66 || (key == 0)
  key = keypad.getKey();
  doTurntableLCD();
    // ROUTINE USING ROTARY ENCODER FOR TURNTABLE AND BUTTON ON IT TO TRIGGER COMMAND
  signed char pos = encoder.getPosition();
  if (pos != 0) {
    positionTurntable += pos;
    if (positionTurntable < 2) {positionTurntable = 2;}
    if (positionTurntable > 3) {positionAccessory = 3;}
    TurntableAddressDble = positionTurntable ; // + 2 ; // 
    encoder.reset();
    doTurntableLCD();   
  }
  buttonState = digitalRead(buttonPin);
  if (buttonState == LOW) {
    delay(50);
    buttonState = digitalRead(buttonPin); // check a 2nd time to be sure
    if (buttonState == LOW) {// check a 2nd time to be sure
      doDCCturntable();  
      do {  // routine to stay here till button released & not triggering accessory
        buttonState = digitalRead(buttonPin); 
        tft.setCursor(0, 100); // start of 5th line
        tft.setTextColor(RED, BLACK);
        tft.print("COMMANDE   ");         
        tft.setTextColor(WHITE, BLACK);
      }      while (buttonState == LOW);
    }
  }
 }  // end while
  if ((key != 66 && (key != 0)) ) {
    doMainLCD();
    delay(200);
    key = 0;
    doDCC(); // driving loco
    group[ActiveAddress]--; // in order to erase message
    doChangeGroupFunction();
  }
} // END DO TURNTABLE

void showFirstLine() {
  // break;
  if (debug == 1) Serial.println(" ");
  tft.setCursor(0, 0); 
  tft.print("                ");// clear
  tft.setCursor(0, 0);
  tft.print("  L");
  tft.print(ActiveAddress + 1);
  tft.print(" = ");
  tft.print(LocoAddress[ActiveAddress]);

  for (int zzz = 0; zzz <= 3; zzz++) {
    if (debug == 1) Serial.print("add # ");
    if (debug == 1) Serial.print(zzz + 1);
    if (debug == 1) Serial.print(" ");
    if (debug == 1) Serial.println(LocoAddress[zzz]);
  }
}

int doChangeGroupFunction(){
  group[ActiveAddress]++;
  if ( group[ActiveAddress] > 3) { group[ActiveAddress]= 0; }
  tft.setCursor(60, 60);
  tft.print("G");
  tft.setTextColor(YELLOW, BLACK);  
  tft.print(group[ActiveAddress]); 
  tft.setTextColor(WHITE, BLACK);
}

void getLocoAddress() {
  int saveAddress =   LocoAddress[ActiveAddress];
  Serial.print("<0>");// power off to DCC++ unit
  int total = 0;
  counter = 0;
  tft.fillScreen(BLACK); // 
  tft.setCursor(0, 0);
  tft.print("Adresse ");
  tft.setCursor(0, 20);
  tft.print("DCC ? ");
  tft.println(ActiveAddress + 1); 
  if (debug == 1) Serial.println(" @ top");
  do {
    key = keypad.getKey();
    if (key == '#' | key == '*') { //abort when either is hit
      //LocoAddress[ActiveAddress] = saveAddress;
      total = saveAddress;
      break;// exit routine if # button pressed - ABORT new address
    }
    if (key) {
      counter++;
      int number =  key - 48;
      total = total * 10 + number;
      if (debug == 1) Serial.print("TOTAL = ");
      if (debug == 1) Serial.println(total);
      tft.setCursor(0, 40); 
      if (total == 0) {   // print multiple zeros for leading zero number
        for (int tempx = 1; tempx <= counter; tempx++) {
          tft.print("0");
        }
      }
      else tft.print(total);
      if (debug == 1) Serial.print("Counter = ");
      if (debug == 1) Serial.print(counter);
      if (debug == 1) Serial.print("  key = ");
      if (debug == 1) Serial.print(key);
      if (debug == 1) Serial.print("   val = ");
      if (debug == 1) Serial.println(number);
    }
  }
  while (counter <= 3); //  collect exactly 4 digits
  LocoAddress[ActiveAddress] = total;
  saveAddresses();
  tft.fillScreen(BLACK);
  doMainLCD();
}

void doDCC() {
  if (debug == 1) Serial.println(LocoDirection[ActiveAddress] );
  Serial.print("<1>");
  Serial.print("<t1 ");
  Serial.print(LocoAddress[ActiveAddress] );//locoID);
  Serial.print(" ");
  Serial.print(LocoSpeed[ActiveAddress] );
  Serial.print(" ");
  Serial.print(LocoDirection[ActiveAddress] );
  Serial.println(">");
}

void doDCCfunction04() {
  Serial.write("<f ");
  Serial.print(LocoAddress[ActiveAddress] );
  Serial.print(" ");
  int fx = LocoFN0to4[ActiveAddress] + 128 ; 
  Serial.print(fx);
  Serial.print(" >");
}

void doDCCfunction58() {
  Serial.write("<f ");
  Serial.print(LocoAddress[ActiveAddress] );
  Serial.print(" ");
  int fx = LocoFN5to8[ActiveAddress] + 176;
  Serial.print(fx);
  Serial.print(" >");
}

void doDCCfunction912() {         //160 = F9-F12
  Serial.write("<f ");
  Serial.print(LocoAddress[ActiveAddress] );
  Serial.print(" ");
  int fx = LocoFN9to12[ActiveAddress] + 160;
  Serial.print(fx);
  Serial.print(" >");
}

void doDCCfunction1320() {
  Serial.write("<f ");
  Serial.print(LocoAddress[ActiveAddress] );
  Serial.print(" 222 ");
  int fx = LocoFN13to20[ActiveAddress];
  Serial.print(fx);
  Serial.print(" >");
}

void doDCCfunction2128() {
  Serial.write("<f ");
  Serial.print(LocoAddress[ActiveAddress] );
  Serial.print(" 223 ");
  int fx = LocoFN21to28[ActiveAddress];
  Serial.print(fx);
  Serial.print(" >");
}

void doDCCpoint() { 
  Serial.print ("<1>");  
  Serial.print ("<a ");
  Serial.print ((( PointAddressDble / 2 - 1 ) / 4) + 1 ); // Point Address, DCC++ works with address + sub address
  Serial.print (" ");
  Serial.print (( PointAddressDble / 2  - 1 ) % 4 );  // Point Sub Address 
  if (PointAddressDble % 2 ) {
    Serial.println (" 0 >");
  }
  else {
    Serial.println (" 1 >"); // Throw - dévié
  }
}

void doDCCaccessory() { 
  Serial.print ("<1>");  
  Serial.print ("<a ");
  Serial.print ( ( (AccessoryAddressDble  / 2 - 1 ) / 4) + 1 ); // Accessory Address, DCC++ works with address + sub address
  Serial.print (" ");
  Serial.print (( AccessoryAddressDble / 2  - 1 ) % 4 );  // Accessory Sub Address 
  if (AccessoryAddressDble % 2 ) {
    Serial.println (" 0 >");  // desactive
  }
  else {
    Serial.println (" 1 >");  // active
  }
}

void doDCCturntable() { 
  Serial.print ("<1>");  
  Serial.print ("<a 17 1 ") ;  // plaque adresse 66
  if (TurntableAddressDble % 2 ) {
    Serial.println (" 0>");  // clockwise sens  horaire
  }
  else {
    Serial.println (" 1>");  // counter clockwise sens anti horaire
  }
  Serial.print ("<a 17 2 1>") ;  // bobine activée
  delay (300);
  Serial.print ("<a 17 2 0>") ;  // bobine désactivée
}

void all2ZeroSpeeed() {  // set flag to 1 to stop, set to 0 to restore
  for (int tempx = 0; tempx <= maxLocos; tempx++) {
    Serial.print("<t1 ");
    Serial.print(LocoAddress[tempx] );//locoID);
    Serial.print(" ");
    if (ZeroSpeedFlag == 1) {
      Serial.print(0);//LocoSpeed[0] );
    }
    else Serial.print(LocoSpeed[0] );
    Serial.print(" ");
    Serial.print(LocoDirection[1] );
    Serial.write(">");
  }
}

void getAddresses() {
  int xxx = 0;
  for (int xyz = 0; xyz <= maxLocos - 1; xyz++) {
    LocoAddress[xyz] = EEPROM.read(xyz * 2) * 256;
    LocoAddress[xyz] = LocoAddress[xyz] + EEPROM.read(xyz * 2 + 1);
    if (LocoAddress[xyz] >= 10000) LocoAddress[xyz] = 3;
    if (debug == 1) Serial.println(" ");
    if (debug == 1) Serial.print("loco = ");
    if (debug == 1) Serial.print(LocoAddress[xyz]);
    if (debug == 1) Serial.print("  address# = ");
    if (debug == 1) Serial.print(xyz + 1);
  }
  if (debug == 1) Serial.println(" ");
  maxLocos = EEPROM.read(20);
  if (debug == 1) Serial.print("EEPROM maxLocos = ");
  if (debug == 1) Serial.println(maxLocos);
  if (maxLocos >= 4) maxLocos = 4;
}

void saveAddresses() {
  int xxx = 0;
  for (int xyz = 0; xyz <= maxLocos - 1; xyz++) {
    xxx = LocoAddress[xyz] / 256;
    if (debug == 1) Serial.println(" ");
    if (debug == 1) Serial.print("loco = ");
    if (debug == 1) Serial.print(LocoAddress[xyz]);
    if (debug == 1) Serial.print("  address# = ");
    if (debug == 1) Serial.print(xyz);
    if (debug == 1) Serial.print(" msb ");
    if (debug == 1) Serial.print(xxx);
    if (debug == 1) Serial.print(" writing to ");
    if (debug == 1) Serial.print(xyz * 2);
    if (debug == 1) Serial.print(" and ");
    if (debug == 1) Serial.print(xyz * 2 + 1);
    EEPROM.write(xyz * 2, xxx);
    xxx = LocoAddress[xyz] - (xxx * 256);
    if (debug == 1) Serial.print(" lsb ");
    if (debug == 1) Serial.print(xxx);
    EEPROM.write(xyz * 2 + 1, xxx);
  }
  EEPROM.write(20, maxLocos);
}

void doMainLCD() {
  tft.setCursor(0,0); // 24,0
  tft.print("V= ");
  tft.setTextColor(YELLOW, BLACK);
  tft.print(LocoSpeed[ActiveAddress], DEC); // 
  tft.print("     ");     // 
  tft.setCursor(80,0);
  tft.setTextColor(CYAN, BLACK);
  if (LocoDirection[ActiveAddress] == 1 ) {
    tft.print(">>> ");
  }
  else {
    tft.print("<<< ");
  }
  tft.setCursor(0, 20); // 2nd line
  tft.setTextColor(WHITE, BLACK);
  tft.print("L= ");
  tft.setTextColor(GREEN, BLACK);
  if (LocoAddress[ActiveAddress] <= 9) {
    tft.print("0");  // add leading zero for single digit addresses
  }
  tft.print(LocoAddress[ActiveAddress] , DEC);
  tft.print("   "); 
  tft.setTextColor(WHITE, BLACK);
  tft.setCursor(96, 20); // pre last char line 2
  tft.print("#");
  tft.setTextColor(GREEN, BLACK);
  tft.setCursor (108, 20);       // last char line 2
  tft.print(ActiveAddress + 1);
  tft.setTextColor(WHITE, BLACK);  
  tft.setCursor(0, 40); // start of 3rd line 
  String temp = "0000" + String(LocoFN0to4[ActiveAddress], BIN);  // pad with leading zeros
  int tlen = temp.length() - 5;
  tft.print(temp.substring(tlen));
  tft.print(" ");  // modif
  temp = "000" + String(LocoFN5to8[ActiveAddress], BIN);
  tlen = temp.length() - 4;
  tft.setCursor(72, 40); // 7th car 3rd line
  tft.print(temp.substring(tlen));
  tft.print("           "); 
  
  tft.setCursor(0, 60); 
  temp = "000" + String(LocoFN9to12[ActiveAddress], BIN);
  tlen = temp.length() - 4;  
  tft.print(temp.substring(tlen));
  tft.print(" "); 
  
  tft.setCursor(0, 80); 
  temp = "0000000" + String(LocoFN13to20[ActiveAddress], BIN);
  tlen = temp.length()-8;  
  tft.print(temp.substring(tlen));
//  tft.print(String(LocoFN13to20[ActiveAddress])); 
  tft.print(" 2"); 
  
  tft.setCursor(0, 100);       
  temp = "0000000" + String(LocoFN21to28[ActiveAddress], BIN);
  tlen = temp.length()- 8;  
  tft.print(temp.substring(tlen));
  tft.print(" 3");       
}

void doPointLCD() {
  tft.setCursor(0,0); // 
  tft.setTextColor(CYAN, BLACK);  
  tft.println("Aiguillage");
  tft.setTextColor(WHITE, BLACK);  
  tft.setCursor(0,20); // // line 2
  tft.print(PointAddressDble / 2 , DEC); 
  tft.print("         ");
  tft.setCursor(0, 40); // line 3
  tft.print(((PointAddressDble / 2 - 1) / 4) + 1, DEC ); // main address
  tft.print(" / ");  
  tft.print(((PointAddressDble / 2 - 1) % 4 ), DEC );  // sub address
  tft.print("     ");    
  // tft.setCursor(96, 40); // before last character line 3
  // tft.print("#");
  tft.setCursor(0, 60); // start of 4th line 
  if (PointAddressDble % 2 ) {
    tft.setTextColor(GREEN, BLACK);
    tft.print("Devie      ");
    tft.setTextColor(WHITE, BLACK);
  }
  else {
    tft.setTextColor(YELLOW, BLACK);
    tft.print("Normal     ");
    tft.setTextColor(WHITE, BLACK);
  }
  tft.setCursor(0, 80); // start of 5th line
  tft.print("Appuyer       ");      
  tft.setCursor(0, 100); // start of 6th line
  tft.print("              ");      
}

void doAccessoryLCD() {
  tft.setCursor(0,0); // 
  tft.setTextColor(CYAN, BLACK);  
  tft.println("Accessoire");
  tft.setTextColor(WHITE, BLACK);  
  tft.setCursor(0,20); // 
  tft.print(AccessoryAddressDble / 2, DEC); 
//  tft.print(((AccessoryAddressDble / 4 ) - 3 ) , DEC );
  tft.print("         ");
  tft.setCursor(0, 20); // line 2
/*  tft.print(((AccessoryAddressDble  - 1) / 2) + 1, DEC ); // main address
  tft.print(" / ");  
  tft.print(((AccessoryAddressDble  - 1) % 2 ), DEC );  // sub address
  tft.print("  ");    
  tft.setCursor(96, 20); // before last character line 2
*/
//  tft.print("         #");
  tft.setCursor(0, 40); // start of 3rd line 
  if (AccessoryAddressDble % 2 ) {
    tft.setTextColor(YELLOW, BLACK);
    tft.print("Desactiver ");
    tft.setTextColor(WHITE, BLACK);
  }
  else {
    tft.setTextColor(GREEN, BLACK);
    tft.print("Activer     ");
    tft.setTextColor(WHITE, BLACK);
  }
  tft.setCursor(0, 60); // start of 4th line
  tft.print("Appuyer       ");      
  tft.setCursor(0, 80); // start of 5th line
  tft.print("              ");      
  tft.setCursor(0, 100); // start of 6th line
  tft.print("              ");      
}

void doTurntableLCD() {
  tft.setCursor(0,0); // 
  tft.setTextColor(CYAN, BLACK);  
  tft.print("Plaque T. ");
  tft.setTextColor(WHITE, BLACK);  
  tft.setCursor(0,20); //
  tft.print("sens :     "); 
  //  tft.print(TurntableAddressDble / 2, DEC); 
  tft.setCursor(0, 40); // start of 3rd line 
  if (TurntableAddressDble % 2 ) {
    tft.setTextColor(YELLOW, BLACK);
    tft.print("Horaire    ");
    tft.setTextColor(WHITE, BLACK);
  }
  else {
    tft.setTextColor(GREEN, BLACK);
    tft.print("Anti-horaire");
    tft.setTextColor(WHITE, BLACK);
  }
  tft.setCursor(0, 60); // start of 4th line
  tft.print("Appuyer       ");      
  tft.setCursor(0, 80); // start of 5th line
  tft.print("              ");      
  tft.setCursor(0, 100); // start of 6th line
  tft.print("              ");  
}
